{ Decrypt / (C) 2006-2012, Andreas Berg. All Rights Reserved. }
unit _dcrypt;

interface

procedure RunDecrypt;

implementation

uses
 SysUtils, _ecommon, _pbar;

var
 oldPerc           : integer;

procedure RunDecrypt;
begin
   oldPerc:= 0;
   DrawProgressBar(BarX, BarY, BarSize, pos, slen);

   {$I-}
   Assign(f, ndir + newFile);
   Rewrite(f);
      cMask:= 3;
      pos:= 64 + 256 + 256;
      while (pos < slen) and (IsRunEnc) do begin
         if (slen - pos) >= 1024 then begin
            BlockRead(fff, eBuf[0], 1024);
            pos:= pos + 1024;
            DoDecrypt(1024, cMask);
            BlockWrite(f, eBuf[0], 1024);
         end else begin
            st:= slen - pos;
            BlockRead(fff, eBuf[0], st);
            pos:= slen;
            DoDecrypt(st, cMask);
            BlockWrite(f, eBuf[0], st);
         end;
         inc(cMask);
         if cMask > 28 then cMask:= 3;
         perc:= ((pos * 100) div slen);
         if (perc > 100) then perc:= 100;

         if perc > oldPerc then begin
            DrawProgressBar(BarX, BarY, BarSize, pos, slen);
            oldPerc:= perc;
         end;

      end;

   Close(f);

   Close(fff);
   {$I+}
end;



end.

